## net.i2p.client
Class I2PClientImpl

    java.lang.Object
      net.i2p.client.I2PClientImpl

All Implemented Interfaces:
  I2PClient

     class I2PClientImpl

extends java.lang.Object
implements I2PClient

Base client implementation

Author:
  jrandom

Field Summary

Fields inherited from interface net.i2p.client.I2PClient
`PROP_RELIABILITY, PROP_RELIABILITY_BEST_EFFORT, PROP_RELIABILITY_GUARANTEED, PROP_TCP_HOST, PROP_TCP_PORT, PROTOCOL_BYTE`

Constructor Summary
`I2PClientImpl()`

Method Summary
`Destination` `createDestination(java.io.OutputStream destKeyStream)` Create the destination with a null payload
`Destination` `createDestination(java.io.OutputStream destKeyStream, Certificate cert)` Create the destination with the given payload and write it out along with the PrivateKey and SigningPrivateKey to the destKeyStream
`I2PSession` `createSession(I2PAppContext context, java.io.InputStream destKeyStream, java.util.Properties options)` Create a new session (though do not connect it yet)
`I2PSession` `createSession(java.io.InputStream destKeyStream, java.util.Properties options)` Create a new session (though do not connect it yet)

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### I2PClientImpl

    I2PClientImpl()

Method Detail

### createDestination

    public Destination createDestination(java.io.OutputStream destKeyStream)
                                  throws I2PException,
                                         java.io.IOException

  Create the destination with a null payload

  Specified by:
    `createDestination` in interface `I2PClient`
  Parameters:
    `destKeyStream` - create a new destination and write out the object to the given stream, formatted as Destination, PrivateKey, and SigningPrivateKey
  Returns:
    new destination
  Throws:
    `I2PException`
    `java.io.IOException`

### createDestination

    public Destination createDestination(java.io.OutputStream destKeyStream,
                                         Certificate cert)
                                  throws I2PException,
                                         java.io.IOException

  Create the destination with the given payload and write it out along with the PrivateKey and SigningPrivateKey to the destKeyStream

  Specified by:
    `createDestination` in interface `I2PClient`
  Parameters:
    `destKeyStream` - location to write out the destination, PrivateKey, and SigningPrivateKey
    `cert` - certificate to tie to the destination
  Returns:
    newly created destination
  Throws:
    `I2PException`
    `java.io.IOException`

### createSession

    public I2PSession createSession(java.io.InputStream destKeyStream,
                                    java.util.Properties options)
                             throws I2PSessionException

  Create a new session (though do not connect it yet)

  Specified by:
    `createSession` in interface `I2PClient`
  Parameters:
    `destKeyStream` - location from which to read the Destination, PrivateKey, and SigningPrivateKey from
    `options` - set of options to configure the router with
  Returns:
    new session allowing a Destination to recieve all of its messages and send messages to any other Destination.
  Throws:
    `I2PSessionException`

### createSession

    public I2PSession createSession(I2PAppContext context,
                                    java.io.InputStream destKeyStream,
                                    java.util.Properties options)
                             throws I2PSessionException

  Create a new session (though do not connect it yet)

  Throws:
    `I2PSessionException`